Voicesmith
==========

Voicesmith app records an audio signal from the built-in microphone, processes it in some way and plays it back through the earphones in real-time. You need to plug in wired earphones or connect the Bluetooth headset to hear the sound.

IMPORTANT! If the app crashes on your smartphone, please be nice -- write me an email and describe what happens. Some of the Android OS releases and smartphone hardwares have their specific nuances. I can only help you, if I receive a detailed error report from you (see below). Giving a bad rating does not help anyone!

There are some of the classical Phase Vocoder effects available. Raise or lower your voice pitch up to 12 semitones, make it sound like a robot, make it detuned or hoarse. Feel free to experiment with this app. Just try to alter your own voice or of somebody else.

Voicesmith can also be used to perform the Delayed Auditory Feedback (DAF) and Frequency-Shifted Auditory Feedback (FAF). The altered auditory feedback is successfully applied in stuttering therapy, to help people speak more fluently. Please ask your therapist to find out more.

You can request support via:

* Email > support@jurihock.de
* GitHub > http://github.com/jurihock/voicesmith/issues
* Facebook > http://www.facebook.com/voicesmith

You should also know:

* The lowest possible feedback delay can vary from smartphone to smartphone.
* The lowest possible delay on Android based smartphones is unfortunately bigger than on special hardware devices.
* You could also try to switch the default sample rate to 22050 Hz or 11025 Hz in order to reduce CPU usage.
* This software is provided "as is", without warranty of any kind.

Now if you have a lot of fun with the Voicesmith, feel free to rate, comment and recommend it!

Binaries
--------

A ready-to-use application is freely available on [Google Play](http://play.google.com/store/apps/details?id=de.jurihock.voicesmith), [F-Droid](http://f-droid.org/repository/browse/?fdid=de.jurihock.voicesmith), [AndroidPIT](http://www.androidpit.com/en/android/market/apps/app/de.jurihock.voicesmith) or [Amazon Appstore](http://www.amazon.com/gp/product/B009JBZ4X4).

Source code and licensing
-------------------------

Voicesmith is an open source project licensed under the [GPL v3](http://www.gnu.org/licenses/gpl.html). Its source code is publicly available on [GitHub](http://github.com/jurihock/voicesmith).

Donate
------

Do you want support this project? Great! :-) Please make a [PayPal](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=RDZAFKVYQJYFA) donation or take a look at my [Amazon.de](http://www.amazon.de/registry/wishlist/32GEAFNKPX67Y) or [Amazon.com](http://www.amazon.com/registry/wishlist/24L7URDMP4U2N) wishlist. Thanks!

Thanks
------

* Udo Zoelzer et al. (Digital Audio Effects)
* Thierry Dutoit, Ferran Marques et al. (Applied Signal Processing)
* Julius Orion Smith (Online Books)
* Mark Borgerding (Kiss FFT)
* Cyril Mottier, Julien Dupouy (GreenDroid)